/*
 * PanelDatosInternautaRegistrado.java
 *
 * Created on 18 de mayo de 2008, 23:18
 */
package org.casino.gui.internauta;

import java.util.regex.Pattern;
import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

/**
 *
 * @author  xaelvil
 */
public class PanelDatosInternautaRegistrado extends javax.swing.JPanel {

    /** Creates new form PanelDatosInternautaRegistrado */
    public PanelDatosInternautaRegistrado() {
        initComponents();
        textoNif.setInputVerifier(new VerificadorDni());
        textoCorreoElectronico.setInputVerifier(new VerificadorCorreoElectronico());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        labelNif = new javax.swing.JLabel();
        labelCorreoElectronico = new javax.swing.JLabel();
        labelNumeroCuenta = new javax.swing.JLabel();
        labelNumeroTarjeta = new javax.swing.JLabel();
        labelPinTarjeta = new javax.swing.JLabel();
        textoNif = new javax.swing.JFormattedTextField();
        textoCorreoElectronico = new javax.swing.JFormattedTextField();
        textoNumeroCuenta = new javax.swing.JFormattedTextField();
        textoNumeroTarjeta = new javax.swing.JFormattedTextField();
        textoPinTarjeta = new javax.swing.JFormattedTextField();
        jButton1 = new javax.swing.JButton();

        labelNif.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelNif.setText("NIF:");

        labelCorreoElectronico.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelCorreoElectronico.setText("Correo Electrónico:");

        labelNumeroCuenta.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelNumeroCuenta.setText("Número de Cuenta:");

        labelNumeroTarjeta.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelNumeroTarjeta.setText("Número de Tarjeta:");

        labelPinTarjeta.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelPinTarjeta.setText("PIN de Tarjeta:");

        textoNif.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textoNifActionPerformed(evt);
            }
        });

        textoCorreoElectronico.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textoCorreoElectronicoActionPerformed(evt);
            }
        });

        jButton1.setText("Guardar");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addComponent(labelNumeroCuenta, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(labelNif, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 130, Short.MAX_VALUE)
                            .addComponent(labelCorreoElectronico, javax.swing.GroupLayout.DEFAULT_SIZE, 130, Short.MAX_VALUE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(textoNumeroCuenta, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                    .addComponent(textoCorreoElectronico, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(textoNif, javax.swing.GroupLayout.PREFERRED_SIZE, 144, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(labelPinTarjeta, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(labelNumeroTarjeta, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(textoNumeroTarjeta, javax.swing.GroupLayout.DEFAULT_SIZE, 153, Short.MAX_VALUE)
                            .addComponent(textoPinTarjeta, javax.swing.GroupLayout.DEFAULT_SIZE, 153, Short.MAX_VALUE)))
                    .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(textoNif, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labelNumeroTarjeta)
                    .addComponent(textoNumeroTarjeta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labelNif, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(labelCorreoElectronico)
                            .addComponent(textoCorreoElectronico, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(textoPinTarjeta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(labelPinTarjeta))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(labelNumeroCuenta))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(34, 34, 34)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(textoNumeroCuenta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton1))))
                .addContainerGap(14, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    private void textoNifActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textoNifActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_textoNifActionPerformed

    private void textoCorreoElectronicoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textoCorreoElectronicoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_textoCorreoElectronicoActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel labelCorreoElectronico;
    private javax.swing.JLabel labelNif;
    private javax.swing.JLabel labelNumeroCuenta;
    private javax.swing.JLabel labelNumeroTarjeta;
    private javax.swing.JLabel labelPinTarjeta;
    private javax.swing.JFormattedTextField textoCorreoElectronico;
    private javax.swing.JFormattedTextField textoNif;
    private javax.swing.JFormattedTextField textoNumeroCuenta;
    private javax.swing.JFormattedTextField textoNumeroTarjeta;
    private javax.swing.JFormattedTextField textoPinTarjeta;
    // End of variables declaration//GEN-END:variables
    class VerificadorDni extends InputVerifier {

        private Pattern p;

        public VerificadorDni() {
            p = Pattern.compile("[1-9]{8}([A-Z]|[a-z])$");
        }

        public boolean verify(JComponent input) {


            boolean verificado = (p.matcher(((JTextField) input).getText()).matches());

            if (!verificado) {
                JOptionPane.showMessageDialog(textoNif, "Introduzca un DNI válido!", "Error", JOptionPane.ERROR_MESSAGE);

            } else {
                String NIF_STRING_ASOCIATION = "TRWAGMYFPDXBNJZSQVHLCKET";

                int dni = Integer.parseInt(((JTextField) input).getText().substring(0, 8));
                char letra = ((JTextField) input).getText().charAt(8);

                if (NIF_STRING_ASOCIATION.charAt(dni % 23) != Character.toUpperCase(letra)) {
                    JOptionPane.showMessageDialog(textoNif, "¡Introduzca un Dni válido!", "Error", JOptionPane.ERROR_MESSAGE);

                }

            }
            return verificado;
        }
    }

    class VerificadorCorreoElectronico extends InputVerifier {

        private Pattern p;

        public VerificadorCorreoElectronico() {
            p = Pattern.compile("^([0-9a-zA-Z]+)([._-]([0-9a-zA-Z]+))*(@)([0-9a-zA-Z]+)([._-]([0-9a-zA-Z]+))*[.]([0-9a-zA-Z]){2,4}$");
        }

        public boolean verify(JComponent input) {


            boolean verificado = (p.matcher(((JTextField) input).getText()).matches());

            if (!verificado) {
                JOptionPane.showMessageDialog(textoCorreoElectronico, "Introduzca un correo electróncio válido!", "Error", JOptionPane.ERROR_MESSAGE);
            }

            return verificado;
        }
    }

}



